-- MultiGroundParticelSystem
-- Specialization for mods with MultiGroundParticelSystems
--
-- @author  Tobias F.(John Deere 6930)
-- @date  23/03/10
--xyzspain 2014 groundReferenceNode

MultiGroundParticelSystem = {};

function MultiGroundParticelSystem.prerequisitesPresent(specializations)
    return true;
end;

function MultiGroundParticelSystem:load(xmlFile)	
	self.multiGroundParticleSystems = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.multiGroundParticleSystems.node(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		if nodei == nil then
			break;
		end; 
        Utils.loadParticleSystem(xmlFile, self.multiGroundParticleSystems, namei, nodei, false, nil, self.baseDirectory)	
		self.multiGroundParticleSystemsdisableTime=0;		
		i = i +1;		
    end;	
    self.groundParticleSystemActive = false;
	
	 self.groundReferenceThreshold = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.groundReferenceNode#threshold"), 0.2);
      self.groundReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundReferenceNode#index"));
      if self.groundReferenceNode == nil then
           self.groundReferenceNode = self.components[1].node;
      end;
	  self.time=0;
end;

function MultiGroundParticelSystem:delete()
    Utils.deleteParticleSystem(self.multiGroundParticleSystems);
end;

function MultiGroundParticelSystem:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MultiGroundParticelSystem:keyEvent(unicode, sym, modifier, isDown)
end;

function MultiGroundParticelSystem:update(dt)

    if self:getIsActive() then
		if self.time > self.multiGroundParticleSystemsdisableTime then
			   Utils.setEmittingState(self.multiGroundParticleSystems, false);
		end;
		
        if self.movingDirection ~= 0 and self.isTurnedOn then
				local x,y,z = getWorldTranslation(self.groundReferenceNode);
                local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
				if terrainHeight+self.groundReferenceThreshold >= y then
           
					if g_currentMission.environment.lastRainScale <= 0.1 and g_currentMission.environment.timeSinceLastRain > 30 then
						self.multiGroundParticleSystemsdisableTime = self.time + 20;
						Utils.setEmittingState(self.multiGroundParticleSystems, true);
						self.groundParticleSystemActive = true;
					end;
				else	
					if self.groundParticleSystemActive then
					Utils.setEmittingState(self.multiGroundParticleSystems, false);			
					self.groundParticleSystemActive = false;
					end;   
				end;
		else
            if self.groundParticleSystemActive then
				Utils.setEmittingState(self.multiGroundParticleSystems, false);			
                self.groundParticleSystemActive = false;
            end;
        end;---isTurnedOn
    end;----active
	
	 
end;


function MultiGroundParticelSystem:draw()
end;

function MultiGroundParticelSystem:onLeave()
    if self.deactivateOnLeave then
        MultiGroundParticelSystem.onDeactivate(self);
    end;
end;

function MultiGroundParticelSystem:onDeactivate()
    if self.groundParticleSystemActive then
		Utils.setEmittingState(self.multiGroundParticleSystems, false);
        self.groundParticleSystemActive = false;
    end;
end;