---xyzspain
---special thanks to Hummel by scripts in Swadro2000
-- edited to fully MP functionality by modelleicher

Phiber_Front= {};


function Phiber_Front.prerequisitesPresent(specializations)
    return true;
end;

function Phiber_Front:load(xmlFile)
	self.setStateEvent= SpecializationUtil.callSpecializationsFunction("setStateEvent");

	
	  
	

	 self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	
		-- desplazamiento de conjuntos
	self.setHydraulicDirection = SpecializationUtil.callSpecializationsFunction("setHydraulicDirection");
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));	
		local ax, ay, az;		
		if self.hydraulics[i].punch ~= nil then
			ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
		else
			ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		end;
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
		self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		self.hydraulics[i].doScale = Utils.getNoNil(getXMLBool(xmlFile, hydraulicName .. "#doScale"), false);
	end;
		self.setJointRotLimit = SpecializationUtil.callSpecializationsFunction("setJointRotLimit");
	self.firstDo = {};
	self.arm = {};
	
	
	
	
	
	
	
	    local numRotParts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.RotParts#count"), 0);
    self.RotParts = {};
    for i=1, numRotParts do
      local partnamei = string.format("vehicle.RotParts.part" .. "%d", i);
      self.RotParts[i] = {};
      self.RotParts[i].index = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
      local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#minRot"));
      self.RotParts[i].minRot = {};
      self.RotParts[i].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.RotParts[i].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.RotParts[i].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#maxRot"));
      self.RotParts[i].maxRot = {};
      self.RotParts[i].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.RotParts[i].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.RotParts[i].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      self.RotParts[i].rotTime = Utils.getNoNil(getXMLString(xmlFile,  partnamei .. "#rotSpeed"), 2)*1000;
    end;
	
	
	local translationNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation1#index"));
    if translationNode1 ~= nil then
        self.translation1 = {};
        self.translation1.node = translationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#minTrans"));
        self.translation1.minTrans = {};
        self.translation1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#maxTrans"));
        self.translation1.maxTrans = {};
        self.translation1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.maxTrans[3] = Utils.getNoNil(z, 0);

	    self.translation1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#transTime"), 2)*1000;
      
    end;
		self.doJointOrientation = false;
		self.attacherJointCopy = nil;
		self.updateJoint = false;
	local count = getXMLInt(xmlFile, "vehicle.rotationParts#count");
	if count ~= nil then
		self.rotationParts = {}
		local rotationPart = self.rotationParts;
		for i=1, count do
			local varName = string.format("rotationPart" .. "%d", i);
			rotationPart[varName] = {};
			local rotationPartname = string.format("vehicle.rotationParts.rotationPart" .. "%d", i);
			rotationPart[varName].index = Utils.indexToObject(self.components, getXMLString(xmlFile, rotationPartname .. "#index"));
			local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, rotationPartname .. "#minRot"));
			rotationPart[varName].minRot = {};
			rotationPart[varName].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
			rotationPart[varName].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
			rotationPart[varName].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
			local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, rotationPartname .. "#maxRot"));
			rotationPart[varName].maxRot = {};
			rotationPart[varName].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
			rotationPart[varName].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
			rotationPart[varName].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

			rotationPart[varName].rotTime = Utils.getNoNil(getXMLInt(xmlFile, rotationPartname .. "#rotTime"), 2)*1000;	
			rotationPart[varName].touchRotLimit = Utils.getNoNil(getXMLInt(xmlFile, rotationPartname .. "#touchRotLimit"), 1)/1000;	
		end;
	end;
 
		--------------------------
	
	self.vehicleType = getXMLString(xmlFile, "vehicle#type");


	
	 self.rotParts =true;

	self.translation1max= false;
	
	-- MP Fix by modelleicher
	------
	self.doMoveHydraulic = 0;
	self.setHydraulicUpDown = Phiber_Front.setHydraulicUpDown; -- self:hydraulicUpDown(state);
	
end;	
function Phiber_Front:delete()
 
 
end;
function Phiber_Front:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Phiber_Front:keyEvent(unicode, sym, modifier, isDown)
	self.on=true;

end;

-- MP Fix by modelleicher:
function Phiber_Front:setHydraulicUpDown(intHydrMoveDirection, noEventSend)
	self.doMoveHydraulic = intHydrMoveDirection;
	if not self.isServer then
		Phiber_MPFixEvent.sendEvent(self, intHydrMoveDirection);
	end;
end;
-- MP Fix ends here

function Phiber_Front:update(dt)

	if self.doJointOrientation and self.attacherVehicle ~= nil then
		for k,v in pairs(self.attacherVehicle.attachedImplements) do
			if v.object == self then
				local joint = self.attacherVehicle.attacherJoints[v.jointDescIndex];
				self.attacherJointCopy = {};
				self.attacherJointCopy.joint = joint;	
				self.attacherJointCopy.minRotCopy = joint.minRot;
				self.attacherJointCopy.maxRotCopy = joint.maxRot;
				joint.minRot = joint.maxRot;
			end;
		end;
		self.doJointOrientation = false;
	end;
	-- MP Fix by modelleicher
	if self:getIsActive() and self.isServer then
		if self.doMoveHydraulic ~= nil then
			local jointDesc = self.attacherJointCopy.joint;
			setJointRotationLimit(jointDesc.jointIndex, 2, true, math.rad(0), math.rad(0));
			jointDesc.moveDown = false;
			self.movingDirection = 1;
			if self.doMoveHydraulic ~= 0 then		
				local wert = nil;
				if self.doMoveHydraulic == 1 then
					wert = true;
				elseif self.doMoveHydraulic == 2 then
					wert = false;
				end;
				if jointDesc.rotationNode ~= nil then
					local x, y, z = getRotation(jointDesc.rotationNode);
					local rot = {x,y,z};
					local newRot = Utils.getMovedLimitedValues(rot, self.attacherJointCopy.maxRotCopy, self.attacherJointCopy.minRotCopy, 3, jointDesc.moveTime, dt, wert);
					setRotation(jointDesc.rotationNode, unpack(newRot));
					jointDesc.maxRot = newRot;
					jointDesc.minRot = newRot;
					setJointFrame(jointDesc.jointIndex, 0, jointDesc.jointTransform);
				end;
			end;
		end;
	end;
	--- MP Fix ends here
	
if self.attacherVehicle then
	if self:getIsActiveForInput() then
	 

		self.isModifierActive = false;
		
	
		   if InputBinding.hasEvent (InputBinding.SWITCH_IMPLEMENT) then 
		   self:setStateEvent("on", not self.on)
			
			end;
		if self.on then
		
		if InputBinding.hasEvent(InputBinding.LOWER_HYDRAULIC) then
				--hydraulicMovingDirection = -1;
				if self.doMoveHydraulic == 0 or self.doMoveHydraulic == 2 then
					self:setHydraulicUpDown(1);
				else
					self:setHydraulicUpDown(0);
				end;
			elseif InputBinding.hasEvent(InputBinding.LIFT_HYDRAULIC) then
				--hydraulicMovingDirection = 1;
				if self.doMoveHydraulic == 0 or self.doMoveHydraulic == 1 then
					self:setHydraulicUpDown(2);
				else
					self:setHydraulicUpDown(0);
				end;
			end;
			
			if InputBinding.hasEvent(InputBinding.TURN_UP) then
			self:setStateEvent("down", not self.down)
			
			
			end;
			if InputBinding.hasEvent(InputBinding.TURN_DOWN) then
			self:setStateEvent("up", not self.up)
		--- MP Fix ends here
			
			end;
			if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
							self:setStateEvent("rotParts", not self.rotParts)
							
					end;

			
		
	end;	
		

			
	
	
	
end;	   

 

end;
	
		if self.rotParts ~= nil   then
				for i=1, table.getn(self.RotParts) do
					local rot = {getRotation(self.RotParts[i].index)};
					local newRot = Utils.getMovedLimitedValues(rot, self.RotParts[i].maxRot, self.RotParts[i].minRot, 3, self.RotParts[i].rotTime, dt, not self.rotParts);
					setRotation(self.RotParts[i].index, unpack(newRot));
				end;
		end;
		
	
	if self.translation1 ~= nil  then 
		local x, y, z = getTranslation(self.translation1.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation1.maxTrans, self.translation1.minTrans, 3, self.translation1.transTime, dt, not self.translation1max); 
		setTranslation(self.translation1.node, unpack(newTrans)); 
	end;
	 if self.down then
			local rotationPart = self.rotationParts.rotationPart1;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
	    end;		
		if self.up then
			local rotationPart = self.rotationParts.rotationPart1;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
	    end;  	

		
	 self:setJointRotLimit(self.componentJoints[2],8, 0, 1000,self.rotParts == false , 0,dt);	
	 self:setJointRotLimit(self.componentJoints[3],3, 0, 1000,self.rotParts == false , 0,dt);	
				for i, jointDesc in pairs(self.componentJoints) do
		setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
		end;
		
		
		self:setHydraulicDirection();

end;



function Phiber_Front:draw()  
  if self.attacherVehicle  then
		g_currentMission:addExtraPrintText(g_i18n:getText(self.vehicleType..".1"));
	end;

	
end;
function Phiber_Front:onAttach(attacherVehicle)
self.rotParts=false;
self.translation1max=true;
 self.doJointOrientation = true;	
	setJointRotationLimit(self.componentJoints[1].jointIndex, 1, true, math.rad(0), math.rad(0));
	setJointRotationLimit(self.componentJoints[1].jointIndex, 2, true, math.rad(0), math.rad(0)); 
	self.on=false;
end;
function Phiber_Front:onDetach()

	self.rotParts=true;
self.translation1max=false;
	self.on=false;
   
  
if self.attacherJointCopy ~= nil then
		local jointDesc = self.attacherJointCopy.joint;
		jointDesc.maxRot = self.attacherJointCopy.maxRotCopy;
		jointDesc.minRot = self.attacherJointCopy.minRotCopy;
	end;
	setJointRotationLimit(self.componentJoints[1].jointIndex, 1, true, math.rad(0), math.rad(0));
	setJointRotationLimit(self.componentJoints[1].jointIndex, 2, true, math.rad(0), math.rad(0));

	
end;




function Phiber_Front:setJointRotLimit(nodei, up, down, speed, value, axle, dt)

	if not self.firstDo[nodei] then
		self.firstDo[nodei] = true;
		self.arm[nodei] = {0}; 
	end; 
	x, y, z = getRotation(nodei);
	rot = {x,y,z};	
	newRotLimit = {}; 
	newRotLimit[nodei] = {0,0,0};
	newRotLimit[nodei] = Utils.getMovedLimitedValues(self.arm[nodei], {down}, {up}, 1, speed * 2, dt, value);
	if math.abs(newRotLimit[nodei][1] - self.arm[nodei][1]) > 0.001 then
		local joint = nodei;
		setJointRotationLimit(joint.jointIndex, axle, true, Utils.degToRad(-newRotLimit[nodei][1]), Utils.degToRad(newRotLimit[nodei][1]));
	end;
	self.arm[nodei] = newRotLimit[nodei];			
end;
function Phiber_Front:setHydraulicDirection()
	for i=1, table.getn(self.hydraulics) do
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);
		
		setDirection(self.hydraulics[i].node, x, y, z, 0, 1, 0);
		local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		if self.hydraulics[i].doScale then
			local xScale, yScale, zScale = getScale(self.hydraulics[i].node);
			local newScale = yScale * (distance / self.hydraulics[i].punchDistance);
			setScale(self.hydraulics[i].node, 1, 1, newScale);
		else
			if self.hydraulics[i].punch ~= nil then
				setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
			end;
		end;
	
	end;
end; 




function Phiber_Front:setStateEvent(level1, value, noEventSend)
	
    if value== true then
      value = "true"
    elseif value==false then
      value = "false"
    elseif value ~= "true" and value ~= "false" then
      value = string.format("%f", value)
    end
	
	Phiber_FrontEvent.sendEvent(self, level1, value, noEventSend);
    	
	if value== "true" then
      value = true
    elseif value=="false" then
      value = false
    elseif value ~= true and value ~= false then
      value = value * 1.0
    end
	
    self[level1]= value;
end;

function Phiber_Front:readStream(streamId, connection)  
	

	self.rotParts = streamReadBool(streamId)
	self.on = streamReadBool(streamId)
	self.down = streamReadBool(streamId)
	self.up = streamReadBool(streamId)
	
end

function Phiber_Front:writeStream(streamId, connection)
	
	streamWriteBool(streamId, self.rotParts)
	streamWriteBool(streamId, self.on)
	streamWriteBool(streamId, self.down)
	streamWriteBool(streamId, self.up)

end;


Phiber_FrontEvent = {};
Phiber_FrontEvent_mt = Class(Phiber_FrontEvent, Event);

InitEventClass(Phiber_FrontEvent, "Phiber_FrontEvent");

function Phiber_FrontEvent:emptyNew()  
    local self = Event:new(Phiber_FrontEvent_mt );
    self.className="Phiber_FrontEvent";
    return self;
end;

function Phiber_FrontEvent:new(object, level1, value) 
    self.object = object;
    self.level1 = level1;
    self.value = value;

    return self;
end;

function Phiber_FrontEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.level1 = streamReadString(streamId);
    self.value = streamReadString(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function Phiber_FrontEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteString(streamId, self.level1 );
    streamWriteString(streamId, self.value );
end;

function Phiber_FrontEvent:run(connection)
    self.object:setStateEvent(self.level1, self.value, true);
    if not connection:getIsServer() then  
      g_server:broadcastEvent(Phiber_FrontEvent:new(self.object, self.level1, self.value), nil, connection, self.object);
    end;
end;

function Phiber_FrontEvent.sendEvent(object, level1, value, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then 
			g_server:broadcastEvent(Phiber_FrontEvent:new(object, level1, value), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(Phiber_FrontEvent:new(object, level1, value));
		end;
	end;
end;

-- MP Fix by modelleicher:
Phiber_MPFixEvent = {};
Phiber_MPFixEvent_mt = Class(Phiber_MPFixEvent, Event);

InitEventClass(Phiber_MPFixEvent, "Phiber_MPFixEvent");

function Phiber_MPFixEvent:emptyNew()  
    local self = Event:new(Phiber_MPFixEvent_mt );
    self.className="Phiber_MPFixEvent";
    return self;
end;

function Phiber_MPFixEvent:new(object, direction) 
    self.object = object;
    self.direction = direction;
    return self;
end;

function Phiber_MPFixEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.direction = streamReadInt32(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function Phiber_MPFixEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteInt32(streamId, self.direction );
end;

function Phiber_MPFixEvent:run(connection)
    self.object:setHydraulicUpDown(self.direction, true);
    if not connection:getIsServer() then  
      g_server:broadcastEvent(Phiber_MPFixEvent:new(self.object, self.direction), nil, connection, self.object);
    end;
end;

function Phiber_MPFixEvent.sendEvent(object, dir, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then 
			g_server:broadcastEvent(Phiber_MPFixEvent:new(object, dir), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(Phiber_MPFixEvent:new(object, dir));
		end;
	end;
end;
